/*
 * Version 1.1
 * CeCILL Copyright (c) 2006-2007, AtolCD, ADULLACT-projet
 * Initiated by AtolCD S.A. & ADULLACT-projet S.A.
 * Developped by StarXpert
 *
 * contact@adullact-projet.coop
 *
 * Ce logiciel est un programme informatique servant à faire circuler des
 * documents au travers d'un circuit de validation, où chaque acteur vise
 * le dossier, jusqu'à l'étape finale de signature.
 *
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 *
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 *
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 *
 */
package fr.starxpert.iparapheur.audit.webscripts;

import com.atolcd.parapheur.model.ParapheurModel;

import java.io.Serializable;
import java.util.*;

import org.alfresco.service.cmr.repository.NodeRef;
import org.alfresco.service.cmr.repository.StoreRef;
import org.alfresco.service.namespace.QName;
import org.alfresco.util.Pair;

import fr.starxpert.iparapheur.audit.cmr.AuditParapheurService;

/**
 * DossiersCreesGet
 *
 * @author cpiassale - StarXpert
 * @author Emmanuel Peralta - Adullact Projet
 *         <p/>
 *         Classe controleur du webscript d'audit sur dossiers crees.
 */
public class DossiersCreesGet extends AbstractDossierGet {

    private String type;
    private String sstype;

    @Override
    protected Pair<String, Serializable> addParapheurKeyVal(String val) {
        NodeRef parapheurRef = new NodeRef(StoreRef.STORE_REF_WORKSPACE_SPACESSTORE, val);
        return new Pair<String, Serializable>(AuditParapheurService.AUDIT_CREATION_PARAPHEUR, parapheurRef);
    }

    @Override
    protected Pair<String, Serializable> addSubtypeKeyVal(String val) {
        sstype = val;
        return null;
    }

    @Override
    protected Pair<String, Serializable> addTypeKeyVal(String val) {
        type = val;
        return null;
    }

    @Override
    protected String getApplicationName() {
        return AuditParapheurService.AUDIT_CREATION_APPLICATION;
    }

    @Override
    protected List<Map<String, Object>> postQueryHook(List<Map<String, Object>> entries) {
        List<Map<String, Object>> entriesMutable = new ArrayList<Map<String, Object>>(entries.size());
        entriesMutable.addAll(entries);

        for (Map<String, Object> entry : entriesMutable) {
            Map<QName, Serializable> properties = (Map<QName, Serializable>) entry.get(AuditParapheurService.AUDIT_CREATION_PROPERTIES);
            String typeMetier = null;
            String sousTypeMetier = null;
            if(properties.containsKey(ParapheurModel.PROP_TYPE_METIER) && properties.get(ParapheurModel.PROP_TYPE_METIER) != null) {
                typeMetier = properties.get(ParapheurModel.PROP_TYPE_METIER).toString();
            }

            if(properties.containsKey(ParapheurModel.PROP_SOUSTYPE_METIER) && properties.get(ParapheurModel.PROP_SOUSTYPE_METIER) != null) {
                sousTypeMetier = properties.get(ParapheurModel.PROP_SOUSTYPE_METIER).toString();
            }

            if (type != null && typeMetier != null && !type.equals(typeMetier)) {
                entries.remove(entry);
                continue;
            }

            if (sstype != null && sousTypeMetier != null && !sstype.equals(sousTypeMetier)) {
                entries.remove(entry);
            }
        }


        return entries;
    }

}
